#!/usr/bin/perl
##############################################
# 
# EveryAuction
# von Matt Hahnfeld, EverySoft
#
# Ins Deutsche bersetzt von Dan Sepeur
# URL: http://www.tag4tag.com
# Mail: dan@tentacle.de
#
# Die erste FreewareAuktion von den Machern
# von EveryChat(tm). 
#
# Version 1.01 (5/10/98) 
#
# Sie drfen dieses Script fr persnliche
# Zwecke und den Einsatz in Firmen, aber nicht
# fr den Verkauf ohne die schriftliche Genehmigung
# des Autors verndern und modifizieren.
# Weiterhin bernimmt der Autor keine Garantie
# fr die beim Einsatz dieses Scriptes entstandenen
# Schaden an Hard und Software.
#
# DER WIEDERVERKAUF IN JEGLICHER FORM IST STRIKT
# VERBOTEN!
#
# (c) 1998 EverySoft
# 
# http://www.everysoft.com/auction/
#
##############################################

##############################################
# Der Input-String hat folgende Form:
# auction.cgi?[category]&[number]&[r|n|u|c|v]
#
# Wenn dieser nicht gegeben ist, zeigt das
# Script beim Aufruf eine bersicht der
# Kategorien.
#
# Wenn ein Kategorieverzeichnis angegeben ist
# zeigt das Script die Eintrge in dieser
# Kategorie.
#
# Wenn das Kategorieverzeichnis und die
# Eintragsnnummer angegeben wird, zeigt
# das Script den Eintrag.
#
# Wenn das Kategorieverzeichnis, die
# Eintragsnummer und der Buchstabe "r"
# angegeben wird, dann wird der Eintrag
# aus der Datenbank gelscht.
#
# Wenn das Kategorieverzeichnis, die
# Eintragsnummer und der Buchstabe "n"
# angegeben wird, dann wird ein neuer Eintrag
# generiert. Die Eintragsnummer wird dann
# ignoriert.
#
# Wenn das Kategorieverzeichnis, die
# Eintragsnummer und der Buchstabe "u"
# angegeben wird, kann man einen neuen 
# User registrieren. Die Eintragsnummer
# wird auch in diesem Falle ignoriert.
#
# Wenn das Kategorieverzeichnis, die
# Eintragsnummer und der Buchstabe "c"
# angegeben wird, dann kann der User seine
# Registrierdaten ndern. Hierbei wird
# wiederum die Eintragsnummer ignoriert.
#
# Wenn das Kategorieverzeichnis, die
# Eintragsnummer und der Buchstabe "v"
# angegeben wird, dann kann der User
# seinen persnlichen Status einsehen.
# Dieser zeigt ihm, an welchen Auktionen
# er aktiv teilgenommen hat und was er
# schon alles ersteigert hat. Die
# Eintragnsummer wird auch hier ignoriert.
#
#
##############################################
# Konfigurationssektion
# Editieren Sie diese Variablen

# Das Basisverzeichnis.  Wir brauchen den
# absoluten Pfad fr das Basisverzeichnis.
# Achten Sie auf den abschliessenden Slash (/).
# ER MUSS GESETZT SEIN, SONST LUFT DIE
# AUKTION NICHT!

$basepath = '/vserv/g/gb-dire1/htdocs/business/auktionen/';

# Verzeichnis fr geschlossene Auktionen
# Hier werden die Informationen ber abgelaufene
# Auktionen gespeichert. Wenn Sie diese Infos
# nicht speichern wollen, so lassen Sie die
# Variable einfach frei. Dies wrde Ihnen ein
# wenig Speicherplatz sparen ('').
# Ansonsten mssen Sie es anlegen.

$closedir = 'closed';

# Userregistrierungsverzeichnis.
# In diesem Verzeichnis werden die Userregistrierungen
# gespeichert. Wenn Sie nicht mchten, da eine
# Registrierung erforderlich ist, lassen Sie die
# Variable einfach frei. Dies spart Ihnen ein wenig
# Speicherplatz. Ansonsten muss das Verzeichnis
# angelegt werden.

$regdir = 'reg';

# Listen Sie hier die Verzeichnisse und die
# damit verbundenen Kategorienamen.
# Die Verzeichnisse mssen Unterverzeichnisse
# Ihres Basisverzeichnisses sein.

%category =	('computer', 'Computer Hardware und Software',
		'buecher', 'Bcher',
		'hobby', 'Hobbies',
		'auto', 'Autos',
		'immobil', 'Immobilien',
		'sonstig', 'Sonstiges' );

# Dies ist das Kennwort um Auktionen zu lschen.
# Lassen Sie diesen Eintrag frei um jedem die
# Mglichkeit zu geben, Eintrge zu lschen.

$adminpass = 'mozart';

# Hier wird es etwas schwieriger.
# Der Autor schreibt, man solle hier die 
# IP-ADRESSE des Mailservers angeben, den
# man zum versenden der Mails an den Bieter
# oder den Verkufer benutzen mchte. Da wir
# aber alle mehr oder weniger Sendmail einsetzen
# habe ich (Dan Sepeur) diese Angabe so umgestellt,
# dass man nur noch den Pfad zu Sendmail angeben
# muss. Es wurde weiter unterhalb auch eine
# entsprechende Routine eingebunden. Also:
# Bitte Pfad zu Sendmail angeben.

$mailserver = "/usr/sbin/sendmail";

# Absender-Email des Emails

$webmasterEmail = "webmaster\@gb-direkt.de";

# Diese Zeile gibt die URL zu Ihrem Server
# wieder. Sie wird benutzt zum senden von
# eMails mit der "berboten-Nachricht".
# Das Script erkennt das Ende der URL
# automatisch. Man braucht keinen abschliessenden
# Slash (/) zu setzen. Wenn Sie keine
# "Sie sind berboten worden" - eMail senden
# wollen, dann lassen Sie dieses Feld bitte leer.

$scripturl = "www.gb-direkt.de";

# Hier knnen Sie die Farben fr die Tabellen
# und mehr angeben, die generiert werden sollen.
# Die voreingestellte Kombination macht schon
# einen sehr professionellen Eindruck.
# Werte mssen im HEX-Format angegeben sein.

$colorbg = '#FFFFFF';
$colortext = '#808080';
$colorlink = '#3333CC';
$colorvlink = '#666699';
$coloralink = '#990099';
$colortablehead = '#BBBBBB';
$colortablebody = '#EEEEEE';

$bgpict = 'http://www.gb-direkt.de/_themes/sumipntg/sumtextb.jpg';

$fonttag = 'face="verdana, arial, helvetica"';
$hfontcol = 'color="#003366"';


# Der Seitenname (Wird in den Kopf jeder Seite gestellt)

$sitename = 'Auktionen bei GB-Direkt';

# Hier kann festgelegt werden, ob die Auktion
# eine bestimmte Zeit nach dem Hchstgebot geschlossen
# werden soll oder ob sie regulr, auch wenn das
# Hchstgebot schon eingegangen ist, den vordefinierten
# Zeitraum ablaufen soll.
# Die Angabe steht fr Minuten.
# Setzen Sie eine 0, so wird die Auktion ganz
# normal ablaufen, setzen Sie eine 5, dann wird
# die Auktion 5 Minuten nach dem Eingang des
# Hchstgebotes geschlossen.

$aftermin = 0;

# File locking aktivieren?   1 (ja)
# fr die meisten Systeme aber setzen Sie es auf
# 0 (nein) wenn Sie Flock-Fehler oder Script-
# Zusammenbrche reportiert haben mchten.

$flock = 1;

# Darf der User posten? 1=ja 0=nein

$newokay = 1;

##############################################
# HAUPTPROGRAMM
# AB HIER BRAUCHEN SIE NICHTS MEHR ZU VERNDERN

##############################################
# Den Seitenheader ausgeben
#
print "Content-type: text/html\n\n";
print qq
<HTML>
<HEAD>
<TITLE>Auktionen</TITLE>
</HEAD>
<BODY BACKGROUND="$bgpict" TEXT="$colortext" BGCOLOR="$colorbg" LINK="$colorlink" VLINK="$colorvlink" ALINK="$coloralink">
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
<TABLE WIDTH="100%" BORDER="0">
	<TR>
		<TD VALIGN="TOP"><H2><FONT $fonttag $hfontcol>$sitename</FONT><H2></TD>
		<TD VALIGN="TOP" ALIGN="RIGHT"><FONT $fonttag><A HREF="javascript:history.back()">Zurck</A><P>
		<INPUT TYPE="text" NAME="searchstring">
		<INPUT TYPE="SUBMIT" VALUE="Suche"><BR>
		<FONT $fonttag SIZE="1"><INPUT TYPE="RADIO" NAME="searchtype" VALUE="keyword" CHECKED>Begriff 
		<INPUT TYPE="RADIO" NAME="searchtype" VALUE="username">Benutzername</FONT></TD>
	</TR>
</TABLE>
</FORM>
;
#
##############################################

# Formulardaten einlesen
&get_form_data;
@ARGV = split(/\\*\&/, $ENV{'QUERY_STRING'});
$ARGV[0] =~ s/\W//g;
$ARGV[1] =~ s/\D//g;

# Hauptprogramm
if ($form{'action'} eq 'bid')
{
	&procbid;
}
elsif ($form{'action'} eq 'new')
{
	&procnew;
}
elsif ($form{'action'} eq 'reg')
{
	&procreg;
}
elsif ($form{'action'} eq 'creg')
{
	&proccreg;
}
elsif ($form{'action'} eq 'repost')
{
	&newitem;
}
elsif ($form{'action'} eq 'closeditems1')
{
	&viewclosed1;
}
elsif ($form{'action'} eq 'closeditems2')
{
	&viewclosed2;
}
elsif ($form{'searchstring'})
{
	&procsearch;
}
elsif ($ARGV[2] eq 'u')
{
	&newreg;
}
elsif ($ARGV[2] eq 'c')
{
	&changereg;
}
elsif ($ARGV[2] eq 'v')
{
	&viewclosed;
}
elsif ($ARGV[2] eq 'n')
{
	&newitem;
}
elsif (($regdir ne "") && ($ARGV[0] eq $regdir))
{
	&dispcat;
} # be sure nobody is trying to hack the user dir
elsif (!(($ARGV[0]) && (-d "$basepath$ARGV[0]")))
{
	&dispcat;
} 
elsif ($ARGV[2] eq 'r')
{
	&remitem;
}
elsif (!(($ARGV[1]) && (-f "$basepath$ARGV[0]/$ARGV[1].dat")))
{
	&displist;
}
else
{
	&dispitem;
}

##############################################
# Seitenfuss ausgeben
#
print "<P><P ALIGN=\"CENTER\"><FONT $fonttag SIZE=\"1\"><A HREF=\"$ENV{'SCRIPT_NAME'}\">Kategorieliste</A> | ";
print "<A HREF=\"$ENV{'SCRIPT_NAME'}\?1\&1\&n\">Neuen Eintrag posten</A> | " if ($newokay);
print "<A HREF=\"$ENV{'SCRIPT_NAME'}?1\&1\&u\">Neue Registrierung</A> | <A HREF=\"$ENV{'SCRIPT_NAME'}?1\&1\&c\">Registrierdaten ndern</A> | " if ($regdir);
print " <A HREF=\"$ENV{'SCRIPT_NAME'}?1\&1\&v\">Abgelaufene Auktionen</A> " if ($regdir) && ($closedir);

# DIE FOLGENDE ZEILEN DRFEN NICHT VERNDERT WERDEN!!!
print qq
<H6 ALIGN="center"><FONT $fonttag><BR><br><I>Powered By <A HREF="http://www.everysoft.com/auction/" TARGET="_blank">EveryAuction 1.01</A></I><br>
<I>Ins Deutsche bersetzt von <A HREF="http://www.tag4tag.com" TARGET="_blank">Tag -4- Tag </A></I><BR>
Korrekturen und Ergnzungen der deutschen Version von <A HREF="http://www.gb-direkt.de" TARGET="_blank">GB-Direkt</A></FONT></H6>
</BODY>
</HTML>
;

#
##############################################

##############################################
# Sub: Anzeigen der Kategorieliste
# 

sub dispcat
{
	print qq
<H3><FONT $fonttag $hfontcol>Auktionskategorien</FONT></H3>
<TABLE WIDTH="100%" BORDER="1">
	<TR BGCOLOR="$colortablehead">
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>Kategorie</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>Eintr&auml;ge</FONT></TH>
	</TR>
	;
	foreach $key (sort keys %category)
	{
		opendir (THEDIR, "$basepath$key");
		@allfiles = grep -T, map "$basepath$key/$_", readdir THEDIR;
		closedir (THEDIR);

		# Anzahl der aufgelisteten Dateien
		$numfiles = @allfiles;
		umask(000);  # UNIX file permission junk
		mkdir("$basepath$key", 0777) unless (-d "$basepath$key");
		print qq
	<TR BGCOLOR="$colortablebody">
		<TD><FONT $fonttag><A HREF="$ENV{'SCRIPT_NAME'}\?$key">$category{$key}</A></FONT></TD>
		<TD><FONT $fonttag>$numfiles</FONT></TD>
	</TR>
		;
	}
	print "</TABLE>\n";
}

##############################################
# Sub: Anzeigen der Liste von Eintrgen
# 

sub displist
{
	print qq
<H3><FONT $fonttag $hfontcol>$category{$ARGV[0]}</FONT></H3>
<TABLE BORDER="1" WIDTH="100%">
	<TR BGCOLOR="$colortablehead">
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>Eintrag</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>Ablauf</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>Anz. Gebote</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag $hfontcol>H&ouml;chstgebot</FONT></TD>
	</TR>
	;

	# Einlesen aller Dateien im Verzeichnis
	opendir (THEDIR, "$basepath$ARGV[0]") || die "Kann Verzeichnis nicht &ouml;ffnen: $!";
	@allfiles = readdir (THEDIR);
	closedir (THEDIR);

	# Numerische Sortierung
	foreach $file (sort { int($a) <=> int($b) } @allfiles)
	{
		if (-T "$basepath$ARGV[0]/$file")
		{
			open (THEFILE, "$basepath$ARGV[0]/$file");
			($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
			close (THEFILE);

			chomp($title, $reserve, $inc, $desc, $image, @bids);
			@lastbid = split(/\[\]/,$bids[$#bids]);
			$file =~ s/\.dat//;
			@closetime = localtime($file);
			$closetime[4]++;
			$camera="";
			$camera = " <FONT $fonttag COLOR=\"#3333FF\" SIZE=\"-1\">[Mit Bild]</FONT>" if ($image);
			print qq
	<TR BGCOLOR="$colortablebody">
		<TD><FONT $fonttag><A HREF="$ENV{'SCRIPT_NAME'}\?$ARGV[0]\&$file">$title</A>$camera</FONT></TD>
		<TD><FONT $fonttag>$closetime[4]/$closetime[3]</FONT></TD>
		<TD><FONT $fonttag>$#bids</FONT></TD>
		<TD><FONT $fonttag>DM $lastbid[2]</FONT></TD>
	</TR>
			;
		}
	}
	print "</TABLE>\n";
}

##############################################
# Sub: Eintrag anzeigen
# Hier wird die Kartei fr einen einzelnen 
# Eintrag angezeigt und alle seine Statistiken.

sub dispitem
{
	open (THEFILE, "$basepath$ARGV[0]/$ARGV[1].dat");
	($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
	close (THEFILE);
	chomp($title, $reserve, $inc, $desc, $image, @bids);
	@firstbid = split(/\[\]/,$bids[0]);
	@lastbid = split(/\[\]/,$bids[$#bids]);
	$nowtime = localtime(time);
	$closetime = localtime($ARGV[1]);
	$image = "<TD><IMG SRC=$image></TD>" if ($image);
	print "<H3><FONT $fonttag>$title</H3><HR><FONT SIZE=\"+1\"><B>Information</B></FONT><HR>\n";
	$reservemet = "";
	$reservemet = "<FONT $fonttag SIZE=\"-1\">(Mindestverkaufspreis noch nicht erreicht)</FONT>" if ($lastbid[2] < $reserve);
	$reservemet = "<FONT $fonttag SIZE=\"-1\">(Mindestverkaufspreis erreicht)</FONT>" if (($lastbid[2] >= $reserve) && ($reserve > 0));
	print qq
<TABLE WIDTH="100%">
	<TR>
		<TD><FONT $fonttag>$image</FONT></TD>
		<TD>
		<TABLE BORDER="1">
			<TR BGCOLOR="$colortablehead">
				<TH><FONT $fonttag>$title</FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Kategorie:</B> <A HREF="$ENV{'SCRIPT_NAME'}\?$ARGV[0]">$category{$ARGV[0]}</A></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Angeboten von:</B> <A HREF=mailto:$firstbid[1]>$firstbid[0]</A></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Heutiges Datum:</B> $nowtime</FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Ablaufdatum:</B> $closetime<BR><FONT SIZE="1">oder $aftermin Minuten nach dem letzten Gebot...</FONT></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Anzahl der Gebote:</B> $#bids</FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Letztes Gebot:</B> DM $lastbid[2] $reservemet</FONT></TD>
			</TR>
		</TABLE>
		</TD>
	</TR>
</TABLE>
	;
	print qq
<HR><FONT $fonttag><FONT SIZE="+1"><B>Beschreibung</B></FONT><HR>
$desc
<HR><FONT SIZE="+1"><B>History der Gebote</B></FONT><HR>
<FONT SIZE="-1"><B>START:</B></FONT></FONT>
	;
	foreach $bid (@bids)
	{
		@thebid = split(/\[\]/,$bid);
		$bidtime = localtime($thebid[3]);
		print "<FONT $fonttag SIZE=\"-1\">$thebid[0] \($bidtime\) - DM $thebid[2]</FONT><BR>";
	}
	if ((time > $ARGV[1]) && (time > (60 * $aftermin + $thebid[3])))
	{
		print "<FONT $fonttag SIZE=\"-1\" COLOR=\"#FF0000\"><B>BIETEN IST NUN NICHT MEHR M&Ouml;GLICH</B></FONT><BR>";
		&closeit;
	}
	else
	{
		&placebid;
	}
}

##############################################
# Sub: Setzen eines Gebots
# 

sub placebid
{
	$lowbid = &parsebid($lastbid[2] + $inc);
	print <<"EOF";
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
<HR><FONT $fonttag SIZE="+1"><B>Gebot abgeben</B></FONT><HR>
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="bid">
	<INPUT TYPE="HIDDEN" NAME="ITEM" VALUE="$ARGV[1]">
	<INPUT TYPE="HIDDEN" NAME="CATEGORY" VALUE="$ARGV[0]">
<FONT $fonttag><B>Das h&ouml;chstgebot ist:</B> DM $lastbid[2]<BR>
<B>Das wenigste, was Sie bieten k&ouml;nnen ist:</B> DM $lowbid
<P>Bitte nehmen Sie zur Kenntnis, da wenn Sie bieten, ein Vertrag zwischen Ihnen und dem Verk&auml;ufer eingegangen wird.
Wenn Sie ein Gebot abgeben, knnen Sie dies nicht wieder r&uuml;ckgngig machen. In einigen L&auml;ndern ist es verboten
zu gewinnen und dann nicht zu zahlen. Mit anderen Worten: Wenn Sie nicht zahlen wollen, dann bieten Sie auch nicht!</FONT>
EOF

	if ($regdir eq "")
	{
		print <<"EOF";
<FONT $fonttag><P><B>Ihr Handle/Alias:</B> <INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30"> (Um Ihr Gebot zu speichern)
<BR><B>Ihre E-Mail Adresse:</B> <INPUT NAME="EMAIL" TYPE="TEXT" SIZE="30"> (mu gltig sein)
<BR><B>Ihr Gebot:</B> DM <INPUT NAME="BID" TYPE="TEXT" SIZE="7" VALUE="$lowbid">
<P><B>Kontakt Information:</B> (wird nur an den Verk&auml;ufer weitergegeben)<BR>
<TT>Voller Name: </TT><BR><INPUT NAME="ADDRESS1" TYPE="TEXT" SIZE="30"><BR>
<TT>Strasse: </TT><BR><INPUT NAME="ADDRESS2" TYPE="TEXT" SIZE="30"><BR>
<TT>Land, PLZ, Stadt: </TT><BR><INPUT NAME="ADDRESS3" TYPE="TEXT" SIZE="30"><P></FONT>
EOF
	}
	else
	{
		print <<"EOF";
<FONT $fonttag><P><B><A HREF="$ENV{'SCRIPT_NAME'}?1\&1\&u">Eine Registrierung</A> ist zum Offerieren oder zum Bieten erforderlich!</B>
<P><B>Ihr Handle/Alias:</B> <INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30"> (um Ihr Gebot zu speichern)
<BR><B>Ihr Passwort:</B> <INPUT NAME="PASSWORD" TYPE="PASSWORD" SIZE="30"> (mu exakt stimmen)
<BR><B>Ihr Gebot:</B> DM <INPUT NAME="BID" TYPE="TEXT" SIZE="7" VALUE="$lowbid"><P>
EOF
	}
	print <<"EOF";
<INPUT TYPE="SUBMIT" VALUE="Gebot speichern">
EOF
}

##############################################
# Sub: Gebot verarbeiten
# 

sub procbid
{
	if (($regdir ne "") && !($newbidflag))
	{
		$form{'ALIAS'} =~ s/\W//g;
		$form{'ALIAS'} = lc($form{'ALIAS'});
		$form{'ALIAS'} = ucfirst($form{'ALIAS'});
		&oops('ALIAS') unless (open(REGFILE, "$basepath$regdir/$form{'ALIAS'}.dat"));
		($password, $form{'EMAIL'}, $form{'ADDRESS1'}, $form{'ADDRESS2'}, $form{'ADDRESS3'}, @userbids) = <REGFILE>;
		close (REGFILE);
		chomp($password, $form{'EMAIL'}, $form{'ADDRESS1'}, $form{'ADDRESS2'}, $form{'ADDRESS3'}, @userbids);
		&oops('PASSWORD') unless ((lc $password) eq (lc $form{'PASSWORD'}));
	}
	&oops('ALIAS') unless ($form{'ALIAS'});
	&oops('EMAIL') unless ($form{'EMAIL'} =~ /.+\@.+/);
	&oops('BID') unless ($form{'BID'} =~ /^(\d+\.?\d*|\.\d+)$/);
	$form{'BID'} = &parsebid($form{'BID'});
	&oops('ADDRESS1') unless ($form{'ADDRESS1'});
	&oops('ADDRESS2') unless ($form{'ADDRESS2'});
	&oops('ADDRESS3') unless ($form{'ADDRESS3'});
	$timenum = time;
	$thetime = localtime(time);
	&oops('ITEM') unless (open ITEM, "$basepath$form{'CATEGORY'}/$form{'ITEM'}.dat");
	($title, $reserve, $inc, $desc, $image, @bids) = <ITEM>;
	close ITEM;
	chomp($title, $reserve, $inc, $desc, $image, @bids);
	@lastbid = split(/\[\]/,$bids[$#bids]);
	if ((((time <= $form{'ITEM'}) 
	|| (time <= (60 * $aftermin + $lastbid[3]))) && ($form{'BID'} >= $lastbid[2] + $inc)) || ($newbidflag == 1))
	{
		&oops('ITEM') unless (open NEWITEM, ">>$basepath$form{'CATEGORY'}/$form{'ITEM'}.dat");
		&filelock if ($flock);
		print NEWITEM "\n$form{'ALIAS'}\[\]$form{'EMAIL'}\[\]$form{'BID'}\[\]$timenum\[\]$form{'ADDRESS1'}\[\]$form{'ADDRESS2'}\[\]$form{'ADDRESS3'}";
		close (NEWITEM);
		print qq
<FONT $fonttag><B>$form{'ADDRESS1'}, Ihr Gebot wurde fr Eintrag $form{'ITEM'} angenommen. 
Die Gebotshhe betrgt derzeit DM $form{'BID'} . Gepostet am $thetime.</B>
<BR>Sie knnen diese Seite fr Ihre Unterlagen drucken.<P> 
<A HREF="$ENV{'SCRIPT_NAME'}\?$form{'CATEGORY'}\&$form{'ITEM'}">Zurck zum Eintrag</A></FONT>
		;
		$flag=0;
		foreach $userbid(@userbids)
		{
			$flag=1 if ("$form{'CATEGORY'}$form{'ITEM'}" eq $userbid);
		}
		if ($flag==0 && $regdir ne "")
		{
			&oops('ALIAS') unless (open(REGFILE, ">>$basepath$regdir/$form{'ALIAS'}.dat"));
			print REGFILE "\n$form{'CATEGORY'}$form{'ITEM'}";
			close REGFILE;
		}
		&sendemail($lastbid[1], 'Sie Sind berboten worden!', 'nobody', $mailserver, "Sie sind fr $title berboten worden\!  Wenn Sie hher bieten wollen, besuchen Sie bitte\:\n\n\thttp://$ENV{'SCRIPT_NAME'}\?$form{'CATEGORY'}\&$form{'ITEM'}\n\nDas derzeitige Gebot ist DM $form{'BID'}.") if (($newbidflag != 1) && $scripturl);
	}
	else
	{
		print "<FONT $fonttag>Entweder ist die Auktion fr diesen Eintrag schon abgelaufen oder Ihr Gebot ist zu niedrig.<BR>Klicken Sie den BACK-Button an Ihrem Browser, schauen Sie sich die Eintragsstatistik an und versuchen Sie es ggf. erneut!</FONT>\n";
	}
}

##############################################
# Sub: Auktion schliessen
# Hier wird der Status "geschlossen" gesetzt

sub closeit
{
	if ($ARGV[0] ne $closedir)
	{
		# We'll use the @firstbid and @lastbid info defined in &dispitem
		if ($closedir)
		{
			umask(000);  # UNIX file permission junk
			mkdir("$basepath$closedir", 0777) unless (-d "$basepath$closedir");		
			print "<FONT $fonttag>Benachrichtigen Sie bitten den Administrator, da dieser Eintrag nicht in das Verzeichnis fr geschlossene Eintrge kopiert werden kann obwohl es abgelaufen ist.</FONT>\n" unless &movefile("$basepath$ARGV[0]/$ARGV[1].dat", "$basepath$closedir/$ARGV[0]$ARGV[1].dat");		
		}
		else
		{
			print "<FONT $fonttag>Benachrichtigen Sie bitte den Administrator da dieser Eintrag nicht gelscht werden kann, obwohl er geschlossen ist.</FONT>\n" unless unlink("$basepath$ARGV[0]/$ARGV[1].dat");
		}
		if ($lastbid[2] >= $reserve)
		{
			&sendemail($lastbid[1], "Auktion geschlossen: $title", $firstbid[1], $mailserver, "Herzlichen Glckwunsch!  Sie sind der Gewinner der Auktion mit der Nummer $ARGV[1].\nIhr Gebot war DM $lastbid[2].\n\nBitte kontaktieren sie den Verkufer um Zahlungsweg und Lieferart abzuklren:\n\n$firstbid[4]\n$firstbid[5]\n$firstbid[6]\n$firstbid[1]\n\nVielen Dank fr die Benutzung der Auktion bei $scripturl!");
		}
		else
		{
			&sendemail($lastbid[1], "Auktion geschlossen: $title", $firstbid[1], $mailserver, "Herzlichen Glckwunsch!  Sie sind der Hchstbietende fr die Auktion mit der Nummer $ARGV[1].\nIhr Gebot war DM $lastbid[2].\n\nLeider traf Ihr Gebot nicht die Preisuntergrenze...\n\nWenn Sie wnschen, knnen Sie mit dem Verkufer in Kontakt treten um einen neuen Preis auszuhandeln:\n\n$firstbid[4]\n$firstbid[5]\n$firstbid[6]\n$firstbid[1]\n\nVielen Dank fr die Nutzung der Auktion bei $scripturl!");
		}
		&sendemail($firstbid[1], "Auktion geschlossen: $title", $lastbid[1], $mailserver, "Die Auktion mit der Nummer $ARGV[1] ist nun geschlossen.\nDas Hchstgebot ist DM $lastbid[2] (Ihr Mindestverkaufspreis war: DM $reserve).\n\nSie knnen gerne den hchstbietenden kontaktieren um ein arrangement zu treffen:\n\n$lastbid[4]\n$lastbid[5]\n$lastbid[6]\n$lastbid[1]\n\nVielen Dank fr die Benutzung der Auktion bei $scripturl!");
	}
}

##############################################
# Sub: Eintrag lschen
# Hier wird ein Eintrag aus der Auktionsdatenbank
# gelscht.

sub remitem
{
	if ($ARGV[3] eq $adminpass)
	{
		if (unlink("$basepath$ARGV[0]/$ARGV[1].dat"))
		{
			print "<FONT $fonttag>Datei wurde erfolgreich gelscht!</FONT>\n";
		}
		else
		{
			print "<FONT $fonttag>Datei konnte nicht gelscht werden!</FONT>\n";
		}
	}
	else
	{
		print "<FONT $fonttag>Sorry...  falsches Administrator-Kennwort zum lschen!</FONT>\n";
	}
}

##############################################
# Sub: Eintrag hinzufgen
# 

sub newitem
{
	$inc = "1.00";
	if ($form{'REPOST'})
	{
		if (open (THEFILE, "$basepath$closedir/$form{'REPOST'}.dat"))
		{
			($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
			$title =~ s/\"//g;  # Anfuehrungsstriche in einem Texteingabefeld geben Probleme
			close (THEFILE);
		}
	}
	print <<"EOF";
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="new">
<H3><FONT $fonttag $hfontcol>Einen Eintrag hinzufgen</FONT></H3>
<TABLE WIDTH="100%" BORDER="1" BGCOLOR="$colortablebody">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Titel/Eintragsname:<BR></B><FONT SIZE="1"(Kein HTML)</FONT></FONT></TD>
		<TD><INPUT NAME="TITLE" VALUE="$title" TYPE="TEXT" SIZE="50" MAXLENGTH="50"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Kategorie:<BR></B>Bitte whlen</FONT></TD>
		<TD><SELECT NAME="CATEGORY">
			<OPTION SELECTED></OPTION>
EOF

	foreach $key (sort keys %category)
	{
		print "<OPTION VALUE=\"$key\">$category{$key}</OPTION>\n";
	}

	print <<"EOF";
		</SELECT>
		</TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Bild URL:<BR></B>Optional. Es darf nicht grsser als 200x200 Pixel sein.</FONT></TD>
		<TD><INPUT NAME="IMAGE" VALUE="$image" TYPE="TEXT" SIZE="50" VALUE="http://"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Tage bis zur Schlieung:<BR></B>1-14<FONT></TD>
		<TD><SELECT NAME="DAYS">
EOF

	for ($i = 1 ; $i <= 14; $i++)
	{
		print "			<OPTION VALUE=\"$i\">$i</OPTION>\n";
	}
			
	print <<"EOF";
		</TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Beschreibung:<BR></B><FONT SIZE="1">Kann HTML enthalten - Die Beschreibung kann Einzelheiten 
		fr das Objekt, Zahl- und Lieferinformationen oder andere Informationen enthalten, die fr den Bieter interessant sein knnten.</FONT></FONT></TD>
		<TD><TEXTAREA NAME="DESC" ROWS="5" COLS="45">$desc</TEXTAREA></TD>
	</TR>
	<TR>
		<TD COLSPAN="2" VALIGN="TOP"><FONT $fonttag>Bitte bedenken Sie, da Sie, wenn Sie hier ein Objekt zum Verkauf eingehen, im Ernstfall einen 
		Vertrag mit dem Kufer eingehen.<br>Wenn Sie hier ein Objekt einbinden, knnen Sie dies nicht mehr rckgngig machen und mssen an den 
		Hchstbietenden verkaufen.<p>
		Mit anderen Worten: Posten Sie hier nicht, wenn Sie auch nicht verkaufen mchten!</FONT>
EOF

	if ($regdir eq "")
	{
		print <<"EOF";
		</TD>
	</TR>
	<TR>
		<TD VALIGN="TOP">>FONT $fonttag><B>Ihr Handle/Alias:<BR></B>Zur Verwaltung Ihres Angebots</FONT></TD>
		<TD><INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihre E-Mail Adresse:<BR></B><FONT SIZE="1">Mu gltig sein>/FONT></FONT></TD>
		<TD><INPUT NAME="EMAIL" TYPE="TEXT" SIZE="30">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Startgebot:</B></FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="BID" TYPE="TEXT" SIZE="7" VALUE="0">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Mindestverkaufspreis:<BR></B><FONT SIZE ="1">Sie mssen nicht unter diesem Preis verkaufen.  
		Bitte frei lassen, falls nicht gewnscht.</FONT></FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="RESERVE" TYPE="TEXT" SIZE="7" VALUE="0">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Mindestgebot:</B></FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="INC" TYPE="TEXT" SIZE="7" VALUE="$inc">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Kontaktinformation:<BR></B><FONT SIZE="1">Wird nur dem Kufer bermittelt</FONT></FONT></TD>
		<TD><TT>Voller Name Name: </TT><BR><INPUT NAME="ADDRESS1" TYPE="TEXT" SIZE="30"><BR>
		<TT>Strasse: </TT><BR><INPUT NAME="ADDRESS2" TYPE="TEXT" SIZE="30"><BR>
		<TT>Land, PLZ, Stadt: </TT><BR><INPUT NAME="ADDRESS3" TYPE="TEXT" SIZE="30"></TD>
	</TR>
</TABLE>
EOF
	}
	else
	{
		print <<"EOF";
		<FONT $fonttag><P><B><A HREF="$ENV{'SCRIPT_NAME'}?1\&1\&u">Die Registrierung</A> ist erforderlich fr das Posten eines Eintrages 
		oder das Bieten auf ein Objekt!</B></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Handle/Alias:<BR></B><FONT SIZE="1">Zur Verwaltung Ihres Angebots</FONT></FONT></TD>
		<TD><INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30">
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Passwort:<BR></B><FONT SIZE="1">Mu gltig sein</FONT></FONT></TD>
		<TD><INPUT NAME="PASSWORD" TYPE="PASSWORD" SIZE="30">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Startgebot:</B></FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="BID" TYPE="TEXT" SIZE="7" VALUE="0"></FONT></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Mindestverkaufspreis:<BR></B><FONT SIZE="1">Sie mssen nicht unter diesem Preis verkaufen.
		<BR>Bitte frei lassen, falls nicht gewnscht.</FONT></FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="RESERVE" TYPE="TEXT" SIZE="7" VALUE="0">
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Mindestgebot:</B><FONT></TD>
		<TD><FONT $fonttag>DM <INPUT NAME="INC" TYPE="TEXT" SIZE="7" VALUE="$inc"></TD>
	</TR>
</TABLE>
EOF
	}
	print <<"EOF";
<CENTER><INPUT TYPE="SUBMIT" VALUE="Voransicht"></CENTER>
EOF
}

##############################################
# Sub: Voransicht
# Zeigt die Voransicht des neuen Eintrages.

sub preview
{
	$nowtime = localtime(time);
	$closetime = localtime($form{'ITEM'});
	$image = "<TD><IMG SRC=$form{'IMAGE'}></TD>" if ($form{'IMAGE'});
	print qq
<H3><FONT $fonttag $hfontcol>$form{'TITLE'} VORANSICHT</FONT></H3><HR>
<FONT $fonttag SIZE="+1"><B>Information</B></FONT><HR>
<TABLE WIDTH="100%">
	<TR>
		<TD><FONT $fonttag>$image</FONT></TD>
	</TR>
		<TD>
		<TABLE BORDER="1">
			<TR BGCOLOR="$colortablehead">
				<TD><FONT $fonttag><B>$form{'TITLE'}</B></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Kategorie:</B> <A HREF="$ENV{'SCRIPT_NAME'}\?$form{'CATEGORY'}">$category{$form{'CATEGORY'}}</A></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Verkauf von:</B> <A HREF="mailto:$form{'EMAIL'}">$form{'ALIAS'}</A></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Aktuelle Zeit:</B> $nowtime</FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Ablaufdatum:</B> $closetime<BR><FONT SIZE="1">oder $aftermin Minuten nach dem letzten Gebot...</FONT></FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Anzahl der Gebote:</B> 0</FONT></TD>
			</TR>
			<TR BGCOLOR="$colortablebody">
				<TD><FONT $fonttag><B>Letztes Gebot:</B> DM $form{'BID'}</FONT></TD>
			</TR>
		</TABLE>
		</TD>
	</TR>
</TABLE>
<HR><FONT $fonttag><FONT SIZE="+1"><FONT $fonttag><B>Beschreibung</B></FONT><HR>
$form{'DESC'}</FONT>
<HR><B><FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">Wenn Ihr Eintrag so korrekt ist, klicken Sie jetzt bitte 
<INPUT TYPE="SUBMIT" VALUE="Fertigstellen">, ansonsten bitte den <I><B>BACK</B></I>-Button am Browser verwenden, um den Eintrag zu ndern.
	<INPUT TYPE="HIDDEN" NAME="FROMPREVIEW" VALUE="1"></B>
	;
	foreach $key (keys %form)
	{
		$form{$key} =~ s/\>/\[greaterthansign\]/gs;
		$form{$key} =~ s/\</\[lessthansign\]/gs;
		$form{$key} =~ s/\"/\[quotes\]/gs;
		print "<INPUT TYPE=\"hidden\" NAME=\"$key\" VALUE=\"$form{$key}\">\n";
	}
	print "</FORM>\n";
}

##############################################
# Sub: Eintrag annehmen und in das System integrieren
# 

sub procnew
{
	if ($regdir ne "")
	{
		$form{'ALIAS'} =~ s/\W//g;
		$form{'ALIAS'} = lc($form{'ALIAS'});
		$form{'ALIAS'} = ucfirst($form{'ALIAS'});
		&oops('ALIAS') unless (open(REGFILE, "$basepath$regdir/$form{'ALIAS'}.dat"));
		($password, $form{'EMAIL'}, $form{'ADDRESS1'}, $form{'ADDRESS2'}, $form{'ADDRESS3'}, @userbids) = <REGFILE>;
		close REGFILE;
		chomp($password, $form{'EMAIL'}, $form{'ADDRESS1'}, $form{'ADDRESS2'}, $form{'ADDRESS3'}, @userbids);
		&oops('PASSWORD') unless ((lc $password) eq (lc $form{'PASSWORD'}));
	}
	&oops('TITLE') unless ($form{'TITLE'} && (length($form{'TITLE'}) < 51));
	$form{'TITLE'} =~ s/\</\&lt\;/g;
	$form{'TITLE'} =~ s/\>/\&gt\;/g;
      &oops('CATEGORY') unless (-d "$basepath$form{'CATEGORY'}");
	$form{'IMAGE'} = "" if ($form{'IMAGE'} eq "http://");
	&oops('DAYS') unless (($form{'DAYS'} > 0) && ($form{'DAYS'} < 15));
	&oops('DESC') unless ($form{'DESC'});
	&oops('ALIAS') unless ($form{'ALIAS'});
	&oops('EMAIL') unless ($form{'EMAIL'} =~ /.+\@.+/);
	&oops('BID') unless ($form{'BID'} =~ /^(\d+\.?\d*|\.\d+)$/);
	&oops('INC') unless (($form{'INC'} =~ /^(\d+\.?\d*|\.\d+)$/) && ($form{'INC'} >= .01));
	$form{'INC'} = &parsebid($form{'INC'});
	$form{'RESERVE'} = &parsebid($form{'RESERVE'});
	&oops('ADDRESS1') unless ($form{'ADDRESS1'});
	&oops('ADDRESS2') unless ($form{'ADDRESS2'});
	&oops('ADDRESS3') unless ($form{'ADDRESS3'});
	$form{'ITEM'} = ($form{'DAYS'} * 86400 + time);
	$form{'ITEM'} = ($form{'DAYS'} * 86400 + time) until (!(-f "$basepath$form{'CATEGORY'}/$form{'ITEM'}.dat"));
	if ($form{'FROMPREVIEW'})
	{
		foreach $key (keys %form)
		{
			$form{$key} =~ s/\[greaterthansign\]/\>/gs;
			$form{$key} =~ s/\[lessthansign\]/\</gs;
			$form{$key} =~ s/\[quotes\]/\"/gs;
		}
		&oops('ITEM') unless (open(NEWAUCTION, ">$basepath$form{'CATEGORY'}/$form{'ITEM'}.dat"));
		print NEWAUCTION "$form{'TITLE'}\n$form{'RESERVE'}\n$form{'INC'}\n$form{'DESC'}\n$form{'IMAGE'}";
		close NEWAUCTION;
		print "<H4><FONT $fonttag>$form{'TITLE'} wurde in folgende Kategorie gepostet\: $category{$form{'CATEGORY'}}...</FONT></H4>\n";
		$newbidflag=1;
		&procbid;
	}
	else
	{
		&preview;
	}
}

##############################################
# Sub: Suchvorgang
# Zeigt die Suchergebnisse an

sub procsearch
{
	print qq
<H3><FONT $fonttag $hfontcol>Suchergebnisse - $form{'searchstring'}</FONT></H3>
<TABLE BORDER="1" WIDTH="100%">
	<TR BGCOLOR="$colortablehead">
		<TH ALIGN="CENTER"><FONT $fonttag>Eintrag</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag>Ablaufdatum</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag>Anzahl der Gebote</FONT></TH>
		<TH ALIGN="CENTER"><FONT $fonttag>Hchstgebot</FONT></TD>
	</TR>
	;
	foreach $key (sort keys %category)
	{
		opendir (THEDIR, "$basepath$key") || die "Kann Verzeichnis nicht ffnen: $!";
		@allfiles = readdir (THEDIR);
		closedir (THEDIR);

		foreach $file (sort { int($a) <=> int($b) } @allfiles)
		{
			if (-T "$basepath$key/$file")
			{
				open (THEFILE, "$basepath$key/$file");
				($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
				close (THEFILE);
				chomp($title, $reserve, $inc, $desc, $image, @bids);
				@lastbid = split(/\[\]/,$bids[$#bids]);
				$file =~ s/\.dat//;
				@closetime = localtime($file);
				$closetime[4]++;
				if($form{'searchtype'} eq 'keyword')
				{
					if (($title =~ /$form{'searchstring'}/i) || ($desc =~ /$form{'searchstring'}/i))
					{
						print qq
	<TR BGCOLOR="$colortablebody">
		<TD><FONT $fonttag><A HREF="$ENV{'SCRIPT_NAME'}\?$key\&$file">$key\: $title</A></FONT></TD>
		<TD><FONT $fonttag>$closetime[4]/$closetime[3]</FONT></TD>
		<TD><FONT $fonttag>$#bids</FONT></TD>
		<TD><FONT $fonttag>DM $lastbid[2]</TD>
	</TR>
						;
					}
				}
				elsif($form{'searchtype'} eq 'username')
				{
					$flag=0;
					foreach $bid(@bids)
					{
						if (($bid =~ /$form{'searchstring'}/i) && ($flag==0))
						{
							print qq
		<TR BGCOLOR="$colortablebody">
			<TD><FONT $fonttag><A HREF="$ENV{'SCRIPT_NAME'}\?$key\&$file">$key\: $title</A></FONT></TD>
			<TD><FONT $fonttag>$closetime[4]/$closetime[3]</FONT></TD>
			<TD><FONT $fonttag>$#bids</FONT></TD>
			<TD><FONT $fonttag>DM $lastbid[2]</FONT></TD>
		</TR>
							;
							$flag=1;
						}
					}
				}
			}
		}
	}
	print "</TABLE>\n";
}

##############################################
# Sub: Benutzerdaten ndern
# 

sub changereg
{
	print <<"EOF";
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="creg">
<H3><FONT $fonttag $hfontcol>ndern der Anschrift und/oder des Passwortes</FONT</H3>
<TABLE WIDTH="100%" BORDER="1" BGCOLOR="$colortablebody">
	<TR>
		<TD COLSPAN="2" VALIGN="TOP"><FONT $fonttag>Dieses Formular erlaubt Ihnen 
		Ihre Anschrift und/oder Ihr Passwort zu ndern.</FONT></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Handle/Alias:<BR></B><FONT SIZE="1">fr die Verifizierung erforderlich</FONT></FONT></TD>
		<TD><INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr derzeitiges Passwort:<BR></B><FONT SIZE="1">fr die Verifizierung erforderlich</FONT></FONT></TD>
		<TD><INPUT NAME="OLDPASS" TYPE="PASSWORD" SIZE="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr neues Passwort:<BR></B></FONT SIZE="1">frei lassen, falls keine nderung erwnscht</FONT></FONT></TD>
		<TD><INPUT NAME="NEWPASS1" TYPE="PASSWORD" SIZE="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Besttigen Ihres neuen Passwortes:<BR></B><FONT SIZE="1">frei lassen, falls nicht erwnscht</FONT></FONT></TD>
		<TD><INPUT NAME="NEWPASS2" TYPE="PASSWORD" SIZE="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Kontaktinformation:<BR></B><FONT SIZE="1">frei lassen, falls nicht erwnscht</FONT></FONT></TD>
		<TD><TT>Voller Name: </TT><BR><INPUT NAME="ADDRESS1" TYPE="TEXT" SIZE="30"><BR>
		<TT>Strasse: </TT><BR><INPUT NAME="ADDRESS2" TYPE="TEXT" SIZE="30"><BR>
		<TT>Land, PLZ, Stadt: </TT><BR><INPUT NAME="ADDRESS3" TYPE="TEXT" SIZE="30"></TD>
	</TR>
</TABLE>
<CENTER><INPUT TYPE="SUBMIT" VALUE="ndern der Registrierdaten"></CENTER>
EOF
}

##############################################
# Sub: Eintragen der neuen Benutzerdaten
# 

sub proccreg
{
	if ($regdir)
	{
		&oops('ALIAS') unless ($form{'ALIAS'});
		&oops('OLD PASSWORD') unless ($form{'OLDPASS'});
		if ($form{'ADDRESS1'})
		{
			&oops('ADDRESS2') unless ($form{'ADDRESS2'});
			&oops('ADDRESS3') unless ($form{'ADDRESS3'});
		}
		if ($form{'NEWPASS1'})
		{
			&oops('NEW PASSWORD VERIFICATION') unless ($form{'NEWPASS2'} eq $form{'NEWPASS1'});
		}
		$form{'ALIAS'} =~ s/\W//g;
		$form{'ALIAS'} = lc($form{'ALIAS'});
		$form{'ALIAS'} = ucfirst($form{'ALIAS'});
		if (-f "$basepath$regdir/$form{'ALIAS'}.dat")
		{
			&oops('ALIAS') unless (open(REGFILE, "$basepath$regdir/$form{'ALIAS'}.dat"));
			($password,$email,$add1,$add2,$add3,@junk) = <REGFILE>;
			chomp($password,$email,$add1,$add2,$add3,@junk);
			close REGFILE;
			&oops('OLD PASSWORD') unless ((lc $password) eq (lc $form{'OLDPASS'}));
			$form{'NEWPASS1'} = $password if !($form{'NEWPASS1'});
			$form{'ADDRESS1'} = $add1 if !($form{'ADDRESS1'});
			$form{'ADDRESS2'} = $add2 if !($form{'ADDRESS2'});
			$form{'ADDRESS3'} = $add3 if !($form{'ADDRESS3'});
			&oops('ALIAS') unless (open NEWREG, ">$basepath$regdir/$form{'ALIAS'}.dat");
			print NEWREG "$form{'NEWPASS1'}\n$email\n$form{'ADDRESS1'}\n$form{'ADDRESS2'}\n$form{'ADDRESS3'}";
			foreach $bid (@junk)
			{
				print NEWREG "\n$bid";
			}
			close NEWREG;
			print "<FONT $fonttag>$form{'ADDRESS1'}, Ihre Userinformationen wurden erfolgreich gendert.</FONT>\n";
		}
		else
		{
			print "<FONT $fonttag>Sorry...  dieser Username ist nicht korrekt.  Wenn Sie noch keinen Alias haben (oder sich dessen nicht mehr erinnern) knnen Sie einen <A HREF=\"$ENV{'SCRIPT_NAME'}?1\&1\&u\">neuen Account</A> generieren.</FONT>\n";
		}
	}
	else
	{
		print "<FONT $fonttag>Benutzer-Registrierung ist auf diesem Server nicht implementiert!<p>Der Administrator hat kein Registrierverzeichnis angegeben...</FONT>\n";
	}
}	

##############################################
# Sub: Neue Registrierung
# 

sub newreg
{
	print <<"EOF";
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="reg">
<H3><FONT $fonttag $hfontcol>Neu-User Registrierung</FONT></H3>
<TABLE WIDTH="100%" BORDER="1" BGCOLOR="$colortablebody">
	<TR>
		<TD COLSPAN="2" VALIGN="TOP"><FONT $fonttag>
		Dieses Formular erlaubt Ihnen, sich bei unseren Online-Auktionen als Verkufer wie auch als Kufer
		zu beteiligen. Fllen Sie es mit exakten Daten aus. Ihr Kennwort wird Ihnen dann direkt per eMail
		zugesandt. Haben Sie ein klein wenig Geduld nach dem Absenden des Formulares. Die Registrierung
		dauert einige Sekunden.</FONT></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Handle/Alias:<BR></B><FONT SIZE="1">wird benutzt, um Ihr Posting zu verwalten</FONT></FONT></TD>
		<TD><INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihre E-Mail Adresse:<BR></B><FONT SIZE="1">muss gltig sein</FONT></FONT></TD>
		<TD><INPUT NAME="EMAIL" TYPE="TEXT" SIZE="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Kontaktinformation:<BR></B><FONT SIZE="1">wird nur dem Verkufer oder dem Kufer mitgeteilt</FONT></FONT></TD>
		<TD><TT>Voller Name: </TT><BR><INPUT NAME="ADDRESS1" TYPE="TEXT" SIZE="30"><BR>
		<TT>Strasse: </TT><BR><INPUT NAME="ADDRESS2" TYPE="TEXT" SIZE="30"><BR>
		<TT>Land, PLZ, Stadt: </TT><BR><INPUT NAME="ADDRESS3" TYPE="TEXT" SIZE="30"></TD>
	</TR>
</TABLE>
<CENTER><INPUT TYPE="SUBMIT" VALUE="Bitte registrieren"></CENTER>
EOF
}

##############################################
# Sub: Neuen User Anlegen
# 

sub procreg
{
	if ($regdir)
	{
		umask(000);  # UNIX file permission junk
		mkdir("$basepath$regdir", 0777) unless (-d "$basepath$regdir");		
		&oops('ALIAS') unless ($form{'ALIAS'});
		&oops('EMAIL') unless ($form{'EMAIL'} =~ /.+\@.+/);
		&oops('ADDRESS1') unless ($form{'ADDRESS1'});
		&oops('ADDRESS2') unless ($form{'ADDRESS2'});
		&oops('ADDRESS3') unless ($form{'ADDRESS3'});
		$form{'ALIAS'} =~ s/\W//g;
		$form{'ALIAS'} = lc($form{'ALIAS'});
		$form{'ALIAS'} = ucfirst($form{'ALIAS'});
		if (!(-f "$basepath$regdir/$form{'ALIAS'}.dat"))
		{
			&oops('NEWREG') unless (open NEWREG, ">$basepath$regdir/$form{'ALIAS'}.dat");
			$newpass = &randompass;
			print NEWREG "$newpass\n$form{'EMAIL'}\n$form{'ADDRESS1'}\n$form{'ADDRESS2'}\n$form{'ADDRESS3'}";
			close NEWREG;
			print "<FONT $fonttag>$form{'ADDRESS1'}, Sie sollten in wenigen Minuten eine eMail bei $form{'EMAIL'} erhalten.  Diese eMail enthlt Ihr Passwort zum posten oder bieten.  Sie knnen Ihr Kennwort direkt ndern, wenn Sie es erhalten haben.  Sollten Sie wider Erwarten keine eMail erhalten, registrieren Sie sich bitte erneut.</FONT>\n";
			&sendemail($form{'EMAIL'}, 'Ihr persnliches Auktions-Passwort', 'nobody', $mailserver, "Hallo $form{'ADDRESS1'},\n\nBITTE ANTWORTEN SIE NICHT AUF DIESE E-MAIL.\n\nVielen Dank, da Sie sich bei unserer Auktion registriert haben!\n\nIhr Auktions-Passwort ist: $newpass\nIhr Alias, den Sie angegeben haben lautet: $form{'ALIAS'}\n\nHerzlichen Dank fr Ihren Besuch!\n\n\tIhr Webmaster bei\n\thttp\:\/\/$scripturl");
		}
		else
		{
			print "<FONT $fonttag>Sorry...  dieser Alias ist schon in Benutzung. Versuchen Sie es bitte erneut!</FONT>\n";
		}
	}
	else
	{
		print "<FONT $fonttag>Benutzer-Registrierung ist auf diesem Server nicht implementiert! Der Administrator hat kein Registrierverzeichnis angegeben...</FONT>\n";
	}
}	

##############################################
# Sub: Generiere ein Passwort
# Generiert ein 8 Buchstaben langes Passwort

sub randompass
{
	srand(time ^ $$);
	@passset = ('a'..'k', 'm'..'n', 'p'..'z', '2'..'9');
	$randpass = "";
	for ($i = 0; $i < 8; $i++)
	{
		$randum_num = int(rand($#passset + 1));
		$randpass .= $passset[$randum_num];
	}
	return $randpass;
}

##############################################
# Sub: Analysiere Gebot
# Dies gibt Ihrem Gebot das entsprechende aussehen...
# z.B. DM ###.##

sub parsebid
{
	$_[0] =~ s/\,//g; 
	@bidamt = split(/\./, $_[0]);
	$bidamt[0] = "0" if (!($bidamt[0]));
	$bidamt[0] = int($bidamt[0]);
	$bidamt[1] = substr($bidamt[1], 0, 2);
	$bidamt[1] = "00" if (length($bidamt[1]) == 0);
	$bidamt[1] = "$bidamt[1]0" if (length($bidamt[1]) == 1);
	return "$bidamt[0].$bidamt[1]";
}

##############################################
# Sub: Oops!
# Hier werden Fehlermeldungen generiert.

sub oops
{
	print "<FONT $fonttag>Irgendetwas stimmt mit dem $_[0] - Feld nicht. Bitte berprfen Sie dies und versuchen Sie es erneut!</FONT>\n";
	die "<FONT $fonttag>Irgendetwas stimmt mit dem $_[0] - Feld nicht. Bitte berprfen Sie dies und versuchen Sie es erneut!\n";
}

##############################################
# Sub: Datei verschieben(file1, file2)
# Dieses Sub verschiebt Datien. Schnell und sauber!

sub movefile
{
	($firstfile, $secondfile) = @_;
	return 0 unless open(FIRSTFILE,$firstfile);
	@lines=<FIRSTFILE>;
	close (FIRSTFILE);
	return 0 unless open(SECONDFILE,">$secondfile");
	foreach $line (@lines)
	{
		print SECONDFILE $line;
	}
	close (SECONDFILE);
	return 0 unless unlink($firstfile);
	return 1;
}


##############################################
# SUB: Send E-mail
# UNIX Sendmail Version
# wird benutzt, wenn die Originalversion nicht
# luft. Man kann dieses SUB ja auch mal ausklammern
# und den Originalmailer einmal laufen lassen.
# Vielleicht gehts ja.
#
# Nimmt:
# (To, Subject, Reply-To, Mail Programm (z.B. sendmail), Message)

sub sendemail
{
	local($TO, $SUBJECT, $REPLYTO, $REMOTE, $THEMESSAGE) = @_;
	@TO=split('\0',$TO);

	open(MAIL, "|$REMOTE -t");

	print MAIL "To: $TO[0]\n";
	print MAIL "From: $webmasterEmail\n";
	print MAIL "Subject: $SUBJECT\n";
	print MAIL "Reply-To: $REPLYTO\n\n";

	# Body der Nachricht
	print MAIL "$THEMESSAGE\n";
	print MAIL "\n";
	print MAIL ".\n";
	close (MAIL);
}


##############################################
# Sub: Einholen der Formulardaten
# 

sub get_form_data
{
	$buffer = "";
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs=split(/&/,$buffer);
	foreach $pair (@pairs)
	{
		@a = split(/=/,$pair);
		$name=$a[0];
		$value=$a[1];
		$value =~ s/\+/ /g;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$value =~ s/~!/ ~!/g;
		$value =~ s/[\n\r]/ /sg;  #remove \n
		$value =~ s/\[\]//g;  #remove []
		push (@data,$name);
		push (@data, $value);
	}
	%form=@data;
	%form;
}

##############################################
# Sub: Eintrge schliessen
# 

sub viewclosed
{
	print <<"EOF";
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="closeditems1">
<H3><FONT $fonttag $hfontcol>Abgelaufene Auktionen einsehen</FONT></H3>
<TABLE WIDTH="100%" BORDER="1" BGCOLOR="$colortablebody">
	<TR>
		<TD COLSPAN="2" VALIGN="TOP"><FONT $fonttag>Dieses Formular erlaubt es Ihnen,
		den Status und die Kontaktinformationen fr abgelaufene Auktionen einzusehen, 
		auf deren Liste Sie standen.</FONT></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Username:<BR></B><FONT SIZE="1">Erforderlich fr die Verifizierung</FONT></FONT></TD>
		<TD><INPUT NAME="ALIAS" TYPE="TEXT" SIZE="30" MAXLENGTH="30"></TD>
	</TR>
	<TR>
		<TD VALIGN="TOP"><FONT $fonttag><B>Ihr Passwort:<BR></B><FONT SIZE="1">Erforderlich fr die Verifizierung</FONT></FONT></TD>
		<TD><INPUT NAME="PASSWORD" TYPE="PASSWORD" SIZE="30"></TD>
	</TR>
</TABLE>
<CENTER><INPUT TYPE="SUBMIT" VALUE="Abgelaufene Auktionen einsehen"></CENTER>
EOF
}

##############################################
# Sub: Eintrge schliessen1
# Zeigt geschlossene Eintrge an

sub viewclosed1
{
	$form{'ALIAS'} =~ s/\W//g;
	$form{'ALIAS'} = lc($form{'ALIAS'});
	$form{'ALIAS'} = ucfirst($form{'ALIAS'});
	&oops('ALIAS') unless (open(REGFILE, "$basepath$regdir/$form{'ALIAS'}.dat"));
	($password,$email,$add1,$add2,$add3,@junk) = <REGFILE>;
	chomp($password,$email,$add1,$add2,$add3,@junk);
	close (REGFILE);
	&oops('PASSWORD') unless ((lc $password) eq (lc $form{'PASSWORD'}));
	print qq
<FORM METHOD="POST" ACTION="$ENV{'SCRIPT_NAME'}">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="closeditems2">
	<INPUT TYPE="HIDDEN" NAME="ALIAS" VALUE="$form{'ALIAS'}">
<SELECT NAME="bidtoview">
	;
	foreach $bid(@junk)
	{
		if (-T "$basepath$closedir/$bid.dat")
		{
			open (THEFILE, "$basepath$closedir/$bid.dat");
			($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
			close (THEFILE);
			chomp($title, $reserve, $inc, $desc, $image, @bids);
			print "<OPTION VALUE=\"$bid\">$bid: $title</OPTION>\n";
		}
	}
	print "</SELECT><BR>\n<INPUT TYPE=\"SUBMIT\" VALUE=\"Meinen Status einsehen\">\n</FORM>\n";
}

##############################################
# Sub: Eintrge schliessen 2
# Zeigt ebenfalls geschlossene Eintrge an.

sub viewclosed2
{
	$form{'bidtoview'} =~ s/\W//g;
	open (THEFILE, "$basepath$closedir/$form{'bidtoview'}.dat") or &oops('ITEM');
	($title, $reserve, $inc, $desc, $image, @bids) = <THEFILE>;
	close (THEFILE);
	chomp($title, $reserve, $inc, $desc, $image, @bids);
	@firstbid = split(/\[\]/,$bids[0]);
	@lastbid = split(/\[\]/,$bids[$#bids]);
	print qq
<H3><FONT $fonttag $hfontcol>$title</FONT></H3>
<HR><FONT $fonttag><FONT SIZE="+1"><B>Beschreibung</B><HR>$desc</FONT>
<HR><FONT SIZE="+1"><B>History der Gebote</B></FONT><HR>
<FONT SIZE="-1"><B>START:</B></FONT>
	;;
	foreach $bid (@bids)
	{
		@thebid = split(/\[\]/,$bid);
		$bidtime = localtime($thebid[3]);
		print "<FONT SIZE=\"-1\">$thebid[0] \($bidtime\) - DM $thebid[2]</FONT><BR>\n";
	}
	print "<P>Mindestverkaufspreis war: DM $reserve<BR>\n";
	print "<HR><FONT SIZE=\"+1\"><B>Kontaktinformation</B></FONT><HR>\n";
	if ($form{'ALIAS'} eq $firstbid[0])
	{
		print qq
Sie waren der Verkufer...<P>
<B>Kufer-Informationen:</B><BR>
<I>Alias</I>: $lastbid[0]<BR>
<I>E-Mail</I>: $lastbid[1]<BR>
<I>Strasse</I>: $lastbid[4]<BR>
$lastbid[5]<BR>
$lastbid[6]<P>
<B>Hchstes Gebot:</B> DM $lastbid[2]
<P><B>Erfolglose Bieter:</B><BR>
		;
		foreach $bid (@bids)
		{
			@thebid = split(/\[\]/,$bid);
			print "<FONT SIZE=\"-1\">$thebid[0] - <A HREF=\"mailto:$thebid[1]\">$thebid[1]</A></FONT><BR>\n";
		}
		print qq
<FORM ACTION="$ENV{'SCRIPT_NAME'}" METHOD="POST">Sie knnen diesen Artikel erneut posten, wenn Sie mchten: 
<INPUT TYPE="SUBMIT" VALUE="Erneut posten">
	<INPUT TYPE="HIDDEN" NAME="action" VALUE="repost">
	<INPUT TYPE="HIDDEN" NAME="REPOST" VALUE="$form{'bidtoview'}">
</FORM>
		;
	}
	elsif ($form{'ALIAS'} eq $lastbid[0])
	{
		print qq
Sie waren Hchstbieter...<P>
<B>Verkufer-Information:</B><BR>
<I>Alias</I>: $firstbid[0]<BR>
<I>E-Mail</I>: $firstbid[1]<BR>
<I>Strasse</I>: $firstbid[4]<BR>
$firstbid[5]<BR>
$firstbid[6]<P>
<B>Ihr Hchstgebot:</B> DM $lastbid[2]<P>
<I>Erinnerung\: Der Verkufer ist nicht zum Verkauf verpflichtet, wenn das Hchstgebot 
noch unter der Preisuntergrenze liegt...</I>
		;	
	}
	else
	{
		print "Sie waren nicht der Gewinner dieser Auktion...  keine weiteren Informationen erhltlich.\n";
	}
	print "</FONT>";
}

##############################################
# Sub: File Lock
# 

sub filelock
{
	flock (NEWITEM, 2);
	seek(NEWITEM, 0, 2);
}
